#include <SWI-Prolog.h>

static record_t *bucketarray;
static record_t nil;
static int capacity;

/* bucketarray(+Capacity) */
static foreign_t pl_bucketarray(term_t cap)
{
	int i;
	if (bucketarray) {
		PL_free(bucketarray);
		bucketarray = NULL;
	}
	if (PL_get_integer(cap, &capacity) && capacity > 0) {
		bucketarray = PL_malloc(capacity * sizeof(record_t));
		for (i=0; i<capacity; i++)
			bucketarray[i] = nil;
		PL_succeed;
	}
	PL_fail;
}

/* lookup(+Hash, -Bucket) */
static foreign_t pl_lookup(term_t hash, term_t bucket)
{
	term_t t = PL_new_term_ref();
	int i;
	if (bucketarray && PL_get_integer(hash, &i) && i>0) {
		i %= capacity;
		PL_recorded(bucketarray[i], t);
		return PL_unify(bucket, t);
	}
	PL_fail;
}

/* record_bucket(+Hash, +Bucket) */
static foreign_t pl_record_bucket(term_t hash, term_t bucket)
{
	int i;
	if (bucketarray && PL_get_integer(hash, &i) && i>0) {
		i %= capacity;
		if (bucketarray[i] != nil)
			PL_erase(bucketarray[i]);
		bucketarray[i] = PL_record(bucket);
		PL_succeed;
	}
	PL_fail;
}

install_t install_bucketarray()
{
	term_t t = PL_new_term_ref();
	PL_put_nil(t);
	nil = PL_record(t);

	PL_register_foreign("bucketarray", 1, pl_bucketarray, 0);
	PL_register_foreign("lookup", 2, pl_lookup, 0);
	PL_register_foreign("record_bucket", 2, pl_record_bucket, 0);
}
