:- load_files(altp).
:- dynamic belief/3.

time_step(belief(I,_,_), I).

% Observations
rule([obs(1,A)],  belief(1, A, r1)).
% Modus ponens
rule([belief(I,A,_), belief(I, A->B, _)],  belief(I+1, B, r2)).
% Extended modus ponens
rule([belief(I, Ps->Q, _), conjunction(Ps),
      all(conjunct(P,Ps), belief(I,P,_))],  belief(I+1, Q, r3)).
% Modus tollens
rule([belief(I,not(B),_), belief(I, A->B, _)], belief(I+1, not(A), r4)).
% Rule 5
rule([I>1, \+ belief(I, u(I-1, w(2)), _)],
     belief(I+1, not(k(1, I, u(I-1, w(2)))), r5)).
% Inheritance
rule([belief(I,A,_)],  belief(I+1, A, r6)).

obs(1, k(2, I, X->Y) -> (k(2, I, X) -> k(2, I+1, Y))).
obs(1, k(2, 1, b(1) -> w(2))).
obs(1, b(1) -> k(2, 1, b(1))).
obs(1, not(b(1)) -> w(1)).
obs(1, not(u(I+1, w(2))) -> not(k(2, I, w(2)))).
obs(1, not(k(1, I+1, u(I, w(2)))) -> not(u(I, w(2)))).

portray(k(J,I,X)) :-
  integer(J), write(k), write(J),
  write('('), print(I), write(', '), print_formula(X), write(')').

