% 3 wise men puzzle
% taken from Elgot-Drapkin's Ph.D. thesis@Maryland
% via Julien Delnaye M.Sc. thesis@Lund
% the parts commented out come from Julien's code, kept for comparison


:- load_files(altp).
:- dynamic belief/3.
:- op(950, xfy, and).

time_step(belief(I,_,_), I).

% Observations
rule([obs(1,A)],  belief(1, A, obs)).
            %rule([[var(i),var(form),var(rule)],
            %     [spec(obs),[var(i),var(alpha)]]],
            %   [[+,var(i),1],var(alpha),r1]),
% Modus ponens
rule([belief(I,A,_), belief(I, A->B, _)],  belief(I+1, B, mp)).
            %rule([[var(i),var(alpha),var(rule1)],
            %      [var(i),['->',var(alpha),var(beta)],var(rule2)]],
            %     [[+,var(i),1],var(beta),r2]),
% Extended modus ponens
rule([belief(I, Ps->Q, _), conjunction(Ps),
      all(conjunct(P,Ps), belief(I,P,_))],  belief(I+1, Q, emp)).
            %rule([[var(i),['->',[and|all(in,emp,free(p))],var(q)],var(rule)],
            %      [var(i),all(out,emp,free(p)),all(out,emp,free(rule))]],
            %     [[+,var(i),1],var(q),r3]),
% Modus tollens
rule([belief(I,not(B),_), belief(I, A->B, _)], belief(I+1, not(A), mt)).
            %rule([[var(i),[not,var(beta)],var(rule1)],
            %      [var(i),['->',var(alpha),var(beta)],var(rule2)]],
            %     [[+,var(i),1],[not,var(alpha)],r4]),
% R8a, we replace conjunction by cases
rule([I>1, \+ belief(I, u(I-1, w(2)), _)], belief(I+1, not(k(1, I, u(I-1, w(2)))), r8a)).
            %rule([[var(i),var(formula),var(rule1)],
            %      [spec(not,f_forms),[var(i),pred(u,[[-,var(i),1],pred(w,[2])]),var(rule2)]],
            %      [spec('<'),[1,var(i)]]],
            %     [[+,var(i),1],[not,pred(k,[1,var(i),pred(u,[[-,var(i),1],pred(w,[2])])])],r8a]),
% R8b, we replace conjunction by cases
rule([I>1, \+ belief(I, u(I-1, w(3)), _)], belief(I+1, not(k(1, I, u(I-1, w(3)))), r8b)).
            %rule([[var(i),var(formula),var(rule1)],
            %      [spec(not,f_forms),[var(i),pred(u,[[-,var(i),1],pred(w,[3])]),var(rule2)]],
            %      [spec('<'),[1,var(i)]]],
            %     [[+,var(i),1],[not,pred(k,[1,var(i),pred(u,[[-,var(i),1],pred(w,[3])])])],r8b]),
% Inheritance
rule([belief(I,A,_)],  belief(I+1, A, inh)).
            %rule([[var(i),var(alpha),var(rule)]],
            %     [[+,var(i),1],var(alpha),r6])
% R7 ??? subsumed by Modus Tollens?
% R9 ??? "not used"???

obs(1, k(2, _, k(3, I, X->Y) -> (k(3, I, X) -> k(3, I+1, Y)))).
obs(1, k(2, _, k(3, 1, b(1) and b(2) -> w(3)))).
obs(1, k(2, _, b(1) and b(2) -> k(3, 1, b(1) and b(2)))).
obs(1, k(2, _, not(b(1) and b(2)) -> (b(1) -> w(2)))).
obs(1, k(2, _, not(u(I+1, w(3))) -> not(k(3, I, w(3))))).
obs(1, not(k(1, I + 1, u(I, X))) -> not(u(I, X))).
obs(1, not(u(I, w(3))) -> k(2, I+1, not(u(I, w(3))))).
obs(1, k(2, I, X->Y) -> (k(2, I, X) -> k(2, I+1, Y))).
obs(1, (k(2, I, not(X1 and X2) -> (Y1 and Y2)) and k(2, I, not(X1 and X2))) -> k(2, I+1, Y1 and Y2)).
obs(1, (k(2, J, (k(3, I, X->Y) -> (k(3, I, X) -> k(3, I+1, Y)))) and k(2, J, k(3, K, (Z1 and Z2)-> W))) -> k(2, J+1, (k(3, K, Z1 and Z2) -> k(3, K+1, W)))).
obs(1, (k(2, J, not(u(I+1, w(3))) -> not(k(3, I, w(3)))) and k(2, J, not(u(K+1, w(3))))) -> k(2, J+1, not(k(3, K, w(3))))).
obs(1, (k(2, I, X->Y) and k(2, I, not(Y))) -> k(2, I+1, not(X))).
obs(1, (k(2, I, (X1 and X2) -> Y) and k(2, I, not(Y))) -> k(2, I+1, not(X1 and X2))).
obs(1, b(1) -> k(2, _, b(1))).
obs(1, not(b(1))->w(1)).
obs(1, not(u(I+1, w(2)))->not(k(2, I, w(2)))).

portray(k(J,I,X)) :-
  integer(J), write(k), write(J),
  write('('), print(I), write(', '), print_formula(X), write(')').

