:- load_files(altp).
:- dynamic belief/2.
:- op(950, xfy, and).

time_step(belief(I,_),I).

% Inference function INF_B

% Rule 1: Clock
rule([],  belief(I, now(I))).
% Rule 2: Observations
rule([obs(I,A)],  belief(I,A)).
% Rule 3: Modus ponens
rule([belief(I, A->B), belief(I,A)],  belief(I+1, B)).
% Rule 4: Extended modus ponens
rule([belief(I, Ps->Q), conjunction(Ps),
      all(conjunct(P,Ps), belief(I,P))],  belief(I+1, Q)).
% Rule 5: Negative introspection
rule([belief(I, A), csf(B,A), B \= k(_,_), \+element(belief(I,B))],
     belief(I+1, \+k(I, B))).
% Rule 6: Contradiction
rule([belief(I, \+A), belief(I, A)],  belief(I+1, contra(I, A, \+A))).
% Rule 7: Inheritance
rule([belief(I, A), A \= now(_),
      \+belief(I, contra(I-1, A, _)),
      \+belief(I, contra(I-1, _, A))],
     belief(I+1, A)).

% The Brother Problem
% "Since I don't know I have a brother, I must not."
% b - a brother exists
% p - a proposition that implies that a brother exists

obs(1, p->b).
obs(1, now(X) and \+k(X-1, b) -> \+b).
%obs(1, b).
%obs(1, p).
