:- [altp].
:- dynamic belief/2.

time_step(belief(I,_),I).

% Observations
rule([obs(I,A)],  belief(I+1, A)).
% Extended modus ponens
rule([belief(I, Ps->Q), all(conjunct(P,Ps), belief(I,P))], belief(I+1, Q)).
% Modus tollens
rule([belief(I,not(B)),belief(I,A->B)], belief(I+1, not(A))).
% Inheritance
rule([belief(I,A)],  belief(I+1, A)).
% Contradiction
rule([belief(I,not(A)), belief(I,A)],   belief(I+1, contra(A,not(A)))).

observations(1, [ free(h1p1,h1p2), free(edge(h1p1,h1p2)), free(edge(h1p1,h1p3)), free(edge(h1p1,h1p4)), free(edge(h1p1,h1e1)), free(edge(h1p4,h1p5)), free(edge(h1p4,h1p6)), free(edge(h1p4,h1p7)), free(edge(h1p7,h1p8)), free(edge(h1p7,h1p9)), free(edge(h1p7,h1e2)), free(edge(h2p1,h2p2)), free(edge(h2p1,h2p3)), free(edge(h2p1,h2p4)), free(edge(h2p1,h2e1)), free(edge(h2p4,h2p5)), free(edge(h2p4,h2p6)), free(edge(h2p4,h2p7)), free(edge(h2p7,h2p8)), free(edge(h2p7,h2p9)), free(edge(h2p7,h2e2)), free(edge(h3p1,h3p2)), free(edge(h3p1,h3p3)), free(edge(h3p1,h3p4)), free(edge(h3p1,h3e1)), free(edge(h3p4,h3p5)), free(edge(h3p4,h3p6)), free(edge(h3p4,h3p7)), free(edge(h3p7,h3p8)), free(edge(h3p7,h3p9)), free(edge(h3p7,h3e2)), free(edge(h4p1,h4p2)), free(edge(h4p1,h4p3)), free(edge(h4p1,h4p4)), free(edge(h4p1,h4e1)), free(edge(h4p4,h4p5)), free(edge(h4p4,h4p6)), free(edge(h4p4,h4p7)), free(edge(h4p7,h4p8)), free(edge(h4p7,h4p9)), free(edge(h4p7,h4e2)), free(edge(h1e1,h2e1)), free(edge(h2e1,h3e1)), free(edge(h3e1,h4e1)), free(edge(h1e2,h2e2)), free(edge(h2e2,h3e2)), free(edge(h3e2,h4e2)), free(edge(h3e2,h4e2)), batteryLevel(999,1), clean(h1p3,1)]).
observations(2, [ batteryLevel(998,2), atR(h1p1,2)]).
observations(3, [ batteryLevel(997,3), clean(h1p1,3)]).
observations(4, [ batteryLevel(996,4), atR(h1p2,4)]).
observations(5, [ batteryLevel(995,5), clean(h1p2,5)]).
observations(6, [ batteryLevel(994,6), atR(h1p1,6)]).
observations(7, [ batteryLevel(993,7), atR(h1p4,7)]).
observations(8, [ batteryLevel(992,8), clean(h1p4,8)]).
observations(9, [ batteryLevel(991,9), atR(h1p5,9)]).
observations(10, [ batteryLevel(990,10), clean(h1p5,10)]).
observations(11, [ batteryLevel(989,11), atR(h1p4,11)]).
observations(12, [ batteryLevel(988,12), atR(h1p6,12)]).
observations(13, [ batteryLevel(987,13), clean(h1p6,13)]).
observations(14, [ batteryLevel(986,14), atR(h1p4,14)]).
observations(15, [ batteryLevel(985,15), atR(h1p7,15)]).
observations(16, [ batteryLevel(984,16), clean(h1p7,16)]).
observations(17, [ batteryLevel(983,17), atR(h1p8,17)]).
observations(18, [ batteryLevel(982,18), clean(h1p8,18)]).
observations(19, [ batteryLevel(981,19), atR(h1p7,19)]).
observations(20, [ batteryLevel(980,20), atR(h1p9,20)]).
observations(21, [ batteryLevel(979,21), clean(h1p9,21), clean(h1,21)]).
observations(22, [ batteryLevel(978,22), atR(h1p7,22)]).
observations(23, [ batteryLevel(977,23), atR(h1p4,23)]).
observations(24, [ batteryLevel(976,24), atR(h1p1,24)]).
observations(27, [ batteryLevel(973,27), atR(h1e1,27)]).
observations(29, [ batteryLevel(971,29), atR(h2e1,29)]).
observations(32, [ batteryLevel(968,32), atR(h2p1,32)]).
observations(33, [ batteryLevel(967,33), atR(h2p4,33)]).
observations(34, [ batteryLevel(966,34), atR(h2p7,34)]).
observations(35, [ batteryLevel(965,35), clean(h2p7,35)]).
observations(36, [ batteryLevel(964,36), atR(h2p9,36)]).
observations(37, [ batteryLevel(963,37), clean(h2p9,37)]).
observations(38, [ batteryLevel(962,38), atR(h2p7,38)]).
observations(39, [ batteryLevel(961,39), atR(h2p8,39)]).
observations(40, [ batteryLevel(960,40), clean(h2p8,40)]).
observations(41, [ batteryLevel(959,41), atR(h2p7,41)]).
observations(44, [ batteryLevel(956,44), atR(h2e2,44)]).
observations(46, [ batteryLevel(954,46), atR(h1e2,46)]).
observations(49, [ batteryLevel(951,49), atR(h1p7,49)]).
observations(50, [ batteryLevel(950,50), atR(h1p4,50)]).
observations(51, [ batteryLevel(949,51), atR(h1p1,51)]).
observations(54, [ batteryLevel(946,54), atR(h1e1,54)]).
observations(56, [ batteryLevel(944,56), atR(h2e1,56)]).
observations(59, [ batteryLevel(941,59), atR(h2p1,59)]).
observations(60, [ batteryLevel(940,60), atR(h2p4,60)]).
observations(61, [ batteryLevel(939,61), clean(h2p4,61)]).
observations(62, [ batteryLevel(938,62), atR(h2p6,62)]).
observations(63, [ batteryLevel(937,63), clean(h2p6,63)]).
observations(64, [ batteryLevel(936,64), atR(h2p4,64)]).
observations(65, [ batteryLevel(935,65), atR(h2p5,65)]).
observations(66, [ batteryLevel(934,66), clean(h2p5,66)]).
observations(67, [ batteryLevel(933,67), atR(h2p4,67)]).
observations(68, [ batteryLevel(932,68), atR(h2p1,68)]).
observations(69, [ batteryLevel(931,69), clean(h2p1,69)]).
observations(70, [ batteryLevel(930,70), atR(h2p3,70)]).
observations(71, [ batteryLevel(929,71), clean(h2p3,71)]).
observations(72, [ batteryLevel(928,72), atR(h2p1,72)]).
observations(73, [ batteryLevel(927,73), atR(h2p2,73)]).
observations(74, [ batteryLevel(926,74), clean(h2p2,74), clean(h2,74)]).
observations(75, [ batteryLevel(925,75), atR(h2p1,75)]).
observations(76, [ batteryLevel(924,76), atR(h2p4,76)]).
observations(77, [ batteryLevel(923,77), atR(h2p7,77)]).
observations(80, [ batteryLevel(920,80), atR(h2e2,80)]).
observations(82, [ batteryLevel(918,82), atR(h3e2,82)]).
observations(85, [ batteryLevel(915,85), atR(h3p7,85)]).
observations(86, [ batteryLevel(914,86), atR(h3p4,86)]).
observations(87, [ batteryLevel(913,87), atR(h3p1,87)]).
observations(88, [ batteryLevel(912,88), atR(h3p3,88)]).
observations(89, [ batteryLevel(911,89), clean(h3p3,89)]).
observations(90, [ batteryLevel(910,90), atR(h3p1,90)]).
observations(91, [ batteryLevel(909,91), clean(h3p1,91)]).
observations(92, [ batteryLevel(908,92), atR(h3p2,92)]).
observations(93, [ batteryLevel(907,93), clean(h3p2,93)]).
observations(94, [ batteryLevel(906,94), atR(h3p1,94)]).
observations(95, [ batteryLevel(905,95), atR(h3p4,95)]).
observations(96, [ batteryLevel(904,96), clean(h3p4,96)]).
observations(97, [ batteryLevel(903,97), atR(h3p5,97)]).
observations(98, [ batteryLevel(902,98), clean(h3p5,98)]).
observations(99, [ batteryLevel(901,99), atR(h3p4,99)]).
observations(100, [ batteryLevel(900,100), atR(h3p6,100)]).
observations(101, [ batteryLevel(899,101), clean(h3p6,101)]).
observations(102, [ batteryLevel(898,102), atR(h3p4,102)]).
observations(103, [ batteryLevel(897,103), atR(h3p7,103)]).
observations(104, [ batteryLevel(896,104), clean(h3p7,104)]).
observations(105, [ batteryLevel(895,105), atR(h3p8,105)]).
observations(106, [ batteryLevel(894,106), clean(h3p8,106)]).
observations(107, [ batteryLevel(893,107), atR(h3p7,107)]).
observations(108, [ batteryLevel(892,108), atR(h3p9,108)]).
observations(109, [ batteryLevel(891,109), clean(h3p9,109), clean(h3,109)]).
observations(110, [ batteryLevel(890,110), atR(h3p7,110)]).
observations(111, [ batteryLevel(889,111), atR(h3p4,111)]).
observations(112, [ batteryLevel(888,112), atR(h3p1,112)]).
observations(115, [ batteryLevel(885,115), atR(h3e1,115)]).
observations(117, [ batteryLevel(883,117), atR(h4e1,117)]).
observations(120, [ batteryLevel(880,120), atR(h4p1,120)]).
observations(121, [ batteryLevel(879,121), atR(h4p4,121)]).
observations(122, [ batteryLevel(878,122), atR(h4p7,122)]).
observations(123, [ batteryLevel(877,123), clean(h4p7,123)]).
observations(124, [ batteryLevel(876,124), atR(h4p9,124)]).
observations(125, [ batteryLevel(875,125), clean(h4p9,125)]).
observations(126, [ batteryLevel(874,126), atR(h4p7,126)]).
observations(127, [ batteryLevel(873,127), atR(h4p8,127)]).
observations(128, [ batteryLevel(872,128), clean(h4p8,128)]).
observations(129, [ batteryLevel(871,129), atR(h4p7,129)]).
observations(132, [ batteryLevel(868,132), atR(h4e2,132)]).
observations(134, [ batteryLevel(866,134), atR(h3e2,134)]).
observations(137, [ batteryLevel(863,137), atR(h3p7,137)]).
observations(138, [ batteryLevel(862,138), atR(h3p4,138)]).
observations(139, [ batteryLevel(861,139), atR(h3p1,139)]).
observations(142, [ batteryLevel(858,142), atR(h3e1,142)]).
observations(144, [ batteryLevel(856,144), atR(h4e1,144)]).
observations(147, [ batteryLevel(853,147), atR(h4p1,147)]).
observations(148, [ batteryLevel(852,148), atR(h4p4,148)]).
observations(149, [ batteryLevel(851,149), clean(h4p4,149)]).
observations(150, [ batteryLevel(850,150), atR(h4p6,150)]).
observations(151, [ batteryLevel(849,151), clean(h4p6,151)]).
observations(152, [ batteryLevel(848,152), atR(h4p4,152)]).
observations(153, [ batteryLevel(847,153), atR(h4p5,153)]).
observations(154, [ batteryLevel(846,154), clean(h4p5,154)]).
observations(155, [ batteryLevel(845,155), atR(h4p4,155)]).
observations(156, [ batteryLevel(844,156), atR(h4p1,156)]).
observations(157, [ batteryLevel(843,157), clean(h4p1,157)]).
observations(158, [ batteryLevel(842,158), atR(h4p3,158)]).
observations(159, [ batteryLevel(841,159), clean(h4p3,159)]).
observations(160, [ batteryLevel(840,160), atR(h4p1,160)]).
observations(161, [ batteryLevel(839,161), atR(h4p2,161)]).
observations(162, [ batteryLevel(838,162), clean(h4p2,162), clean(h4,162)]).
observations(163, [ batteryLevel(837,163), atR(h4p1,163)]).
observations(164, [ batteryLevel(836,164), atR(h4p4,164)]).
observations(165, [ batteryLevel(835,165), atR(h4p7,165)]).
observations(168, [ batteryLevel(832,168), atR(h4e2,168)]).
observations(170, [ batteryLevel(830,170), atR(h3e2,170)]).
observations(173, [ batteryLevel(827,173), atR(h3p7,173)]).
observations(174, [ batteryLevel(826,174), atR(h3p4,174)]).
observations(175, [ batteryLevel(825,175), atR(h3p1,175)]).
observations(178, [ batteryLevel(822,178), atR(h3e1,178)]).
observations(180, [ batteryLevel(820,180), atR(h2e1,180)]).
observations(183, [ batteryLevel(817,183), atR(h2p1,183)]).
observations(184, [ batteryLevel(816,184), atR(h2p4,184)]).
observations(185, [ batteryLevel(815,185), atR(h2p7,185)]).
observations(188, [ batteryLevel(812,188), atR(h2e2,188)]).
observations(190, [ batteryLevel(810,190), atR(h1e2,190)]).
observations(193, [ batteryLevel(807,193), atR(h1p7,193)]).
observations(194, [ batteryLevel(806,194), atR(h1p4,194)]).
observations(195, [ batteryLevel(805,195), atR(h1p1,195)]).
observations(196, [ batteryLevel(804,196), atR(h1p3,196)]).
observations(359, [ batteryLevel(1000,359)]).
observations(419, [ batteryLevel(1000,419), mailLoaded(419)]).
observations(420, [ batteryLevel(999,420), atR(h1p1,420)]).
observations(421, [ batteryLevel(998,421), atR(h1p2,421)]).
observations(423, [ batteryLevel(996,423), mailAt(h1p2,423), mailCollected(h1p2,423)]).
observations(424, [ batteryLevel(995,424), atR(h1p1,424)]).
observations(425, [ batteryLevel(994,425), atR(h1p4,425)]).
observations(426, [ batteryLevel(993,426), atR(h1p5,426)]).
observations(428, [ batteryLevel(991,428), mailAt(h1p5,428), mailCollected(h1p5,428)]).
observations(429, [ batteryLevel(990,429), atR(h1p4,429)]).
observations(430, [ batteryLevel(989,430), atR(h1p6,430)]).
observations(432, [ batteryLevel(987,432), mailAt(h1p6,432), mailCollected(h1p6,432)]).
observations(433, [ batteryLevel(986,433), atR(h1p4,433)]).
observations(434, [ batteryLevel(985,434), atR(h1p7,434)]).
observations(435, [ batteryLevel(984,435), atR(h1p8,435)]).
observations(437, [ batteryLevel(982,437), mailAt(h1p8,437), mailCollected(h1p8,437)]).
observations(438, [ batteryLevel(981,438), atR(h1p7,438)]).
observations(439, [ batteryLevel(980,439), atR(h1p9,439)]).
observations(441, [ batteryLevel(978,441), mailAt(h1p9,441), mailCollected(h1p9,441), mailAt(h1,441)]).
observations(442, [ batteryLevel(977,442), atR(h1p7,442)]).
observations(443, [ batteryLevel(976,443), atR(h1p4,443)]).
observations(444, [ batteryLevel(975,444), atR(h1p1,444)]).
observations(447, [ batteryLevel(972,447), atR(h1e1,447)]).
observations(449, [ batteryLevel(970,449), atR(h2e1,449)]).
observations(452, [ batteryLevel(967,452), atR(h2p1,452)]).
observations(453, [ batteryLevel(966,453), atR(h2p4,453)]).
observations(454, [ batteryLevel(965,454), atR(h2p7,454)]).
observations(455, [ batteryLevel(964,455), atR(h2p9,455)]).
observations(457, [ batteryLevel(962,457), mailAt(h2p9,457), mailCollected(h2p9,457)]).
observations(458, [ batteryLevel(961,458), atR(h2p7,458)]).
observations(459, [ batteryLevel(960,459), atR(h2p8,459)]).
observations(461, [ batteryLevel(958,461), mailAt(h2p8,461), mailCollected(h2p8,461)]).
observations(462, [ batteryLevel(957,462), atR(h2p7,462)]).
observations(465, [ batteryLevel(954,465), atR(h2e2,465)]).
observations(467, [ batteryLevel(952,467), atR(h1e2,467)]).
observations(470, [ batteryLevel(949,470), atR(h1p7,470)]).
observations(471, [ batteryLevel(948,471), atR(h1p4,471)]).
observations(472, [ batteryLevel(947,472), atR(h1p1,472)]).
observations(475, [ batteryLevel(944,475), atR(h1e1,475)]).
observations(477, [ batteryLevel(942,477), atR(h2e1,477)]).
observations(480, [ batteryLevel(939,480), atR(h2p1,480)]).
observations(481, [ batteryLevel(938,481), atR(h2p4,481)]).
observations(482, [ batteryLevel(937,482), atR(h2p6,482)]).
observations(484, [ batteryLevel(935,484), mailAt(h2p6,484), mailCollected(h2p6,484)]).
observations(485, [ batteryLevel(934,485), atR(h2p4,485)]).
observations(486, [ batteryLevel(933,486), atR(h2p5,486)]).
observations(488, [ batteryLevel(931,488), mailAt(h2p5,488), mailCollected(h2p5,488)]).
observations(489, [ batteryLevel(930,489), atR(h2p4,489)]).
observations(490, [ batteryLevel(929,490), atR(h2p1,490)]).
observations(491, [ batteryLevel(928,491), atR(h2p3,491)]).
observations(493, [ batteryLevel(926,493), mailAt(h2p3,493), mailCollected(h2p3,493)]).
observations(494, [ batteryLevel(925,494), atR(h2p1,494)]).
observations(495, [ batteryLevel(924,495), atR(h2p2,495)]).
observations(497, [ batteryLevel(922,497), mailAt(h2p2,497), mailCollected(h2p2,497), mailAt(h2,497)]).
observations(498, [ batteryLevel(921,498), atR(h2p1,498)]).
observations(499, [ batteryLevel(920,499), atR(h2p4,499)]).
observations(500, [ batteryLevel(919,500), atR(h2p7,500)]).
observations(503, [ batteryLevel(916,503), atR(h2e2,503)]).
observations(505, [ batteryLevel(914,505), atR(h3e2,505)]).
observations(508, [ batteryLevel(911,508), atR(h3p7,508)]).
observations(509, [ batteryLevel(910,509), atR(h3p4,509)]).
observations(510, [ batteryLevel(909,510), atR(h3p1,510)]).
observations(511, [ batteryLevel(908,511), atR(h3p3,511)]).
observations(513, [ batteryLevel(906,513), mailAt(h3p3,513), mailCollected(h3p3,513)]).
observations(514, [ batteryLevel(905,514), atR(h3p1,514)]).
observations(515, [ batteryLevel(904,515), atR(h3p2,515)]).
observations(517, [ batteryLevel(902,517), mailAt(h3p2,517), mailCollected(h3p2,517)]).
observations(518, [ batteryLevel(901,518), atR(h3p1,518)]).
observations(519, [ batteryLevel(900,519), atR(h3p4,519)]).
observations(520, [ batteryLevel(899,520), atR(h3p5,520)]).
observations(522, [ batteryLevel(897,522), mailAt(h3p5,522), mailCollected(h3p5,522)]).
observations(523, [ batteryLevel(896,523), atR(h3p4,523)]).
observations(524, [ batteryLevel(895,524), atR(h3p6,524)]).
observations(526, [ batteryLevel(893,526), mailAt(h3p6,526), mailCollected(h3p6,526)]).
observations(527, [ batteryLevel(892,527), atR(h3p4,527)]).
observations(528, [ batteryLevel(891,528), atR(h3p7,528)]).
observations(529, [ batteryLevel(890,529), atR(h3p8,529)]).
observations(531, [ batteryLevel(888,531), mailAt(h3p8,531), mailCollected(h3p8,531)]).
observations(532, [ batteryLevel(887,532), atR(h3p7,532)]).
observations(533, [ batteryLevel(886,533), atR(h3p9,533)]).
observations(535, [ batteryLevel(884,535), mailAt(h3p9,535), mailCollected(h3p9,535), mailAt(h3,535)]).
observations(536, [ batteryLevel(883,536), atR(h3p7,536)]).
observations(537, [ batteryLevel(882,537), atR(h3p4,537)]).
observations(538, [ batteryLevel(881,538), atR(h3p1,538), not(free(edge(h3p1,h3e1,538)))	%541 contra occurs, plannining takes 5 five minutes. 546 first move in other direction, before that only decreasing batteryLevel
]).
observations(540, [ batteryLevel(880,540)]).
observations(542, [ batteryLevel(879,542)]).
observations(544, [ batteryLevel(878,544)]).
observations(546, [ batteryLevel(876,546)]).
observations(547, [ batteryLevel(875,547), atR(h3p4,547)]).
observations(548, [ batteryLevel(874,548), atR(h3p7,548)]).
observations(551, [ batteryLevel(871,551), atR(h3e2,551)]).
observations(553, [ batteryLevel(869,553), atR(h4e2,553)]).
observations(556, [ batteryLevel(866,556), atR(h4p7,556)]).
observations(557, [ batteryLevel(865,557), atR(h4p9,557)]).
observations(559, [ batteryLevel(863,559), atR(h4p9,559), mailAt(h4p9,559), mailCollected(h4p9,559)]).
observations(560, [ batteryLevel(862,560), atR(h4p7,560)]).
observations(561, [ batteryLevel(861,561), atR(h4p8,561)]).
observations(563, [ batteryLevel(859,563), mailAt(h4p8,563), mailCollected(h4p8,563)]).
observations(564, [ batteryLevel(858,564), atR(h4p7,564)]).
observations(567, [ batteryLevel(855,567), atR(h4e2,567)]).
observations(569, [ batteryLevel(853,569), atR(h3e2,569)]).
observations(572, [ batteryLevel(850,572), atR(h3p7,572)]).
observations(573, [ batteryLevel(849,573), atR(h3p4,573)]).
observations(574, [ batteryLevel(848,574), atR(h3p1,574)]).
observations(577, [ batteryLevel(845,577), atR(h3e1,577)]).
observations(579, [ batteryLevel(843,579), atR(h4e1,579)]).
observations(582, [ batteryLevel(840,582), atR(h4p1,582)]).
observations(583, [ batteryLevel(839,583), atR(h4p4,583)]).
observations(584, [ batteryLevel(838,584), atR(h4p6,584)]).
observations(586, [ batteryLevel(836,586), mailAt(h4p6,586), mailCollected(h4p6,586)]).
observations(587, [ batteryLevel(835,587), atR(h4p4,587)]).
observations(588, [ batteryLevel(834,588), atR(h4p5,588)]).
observations(590, [ batteryLevel(832,590), mailAt(h4p5,590), mailCollected(h4p5,590)]).
observations(591, [ batteryLevel(831,591), atR(h4p4,591)]).
observations(592, [ batteryLevel(830,592), atR(h4p1,592)]).
observations(593, [ batteryLevel(829,593), atR(h4p3,593)]).
observations(595, [ batteryLevel(827,595), mailAt(h4p3,595), mailCollected(h4p3,595)]).
observations(596, [ batteryLevel(826,596), atR(h4p1,596)]).
observations(597, [ batteryLevel(825,597), atR(h4p2,597)]).
observations(599, [ batteryLevel(823,599), mailAt(h4p2,599), mailCollected(h4p2,599), mailAt(h4,599)]).
observations(600, [ batteryLevel(822,600), atR(h4p1,600)]).
observations(601, [ batteryLevel(821,601), atR(h4p4,601)]).
observations(602, [ batteryLevel(820,602), atR(h4p7,602)]).
observations(605, [ batteryLevel(817,605), atR(h4e2,605)]).
observations(607, [ batteryLevel(815,607), atR(h3e2,607)]).
observations(610, [ batteryLevel(812,610), atR(h3p7,610)]).
observations(611, [ batteryLevel(811,611), atR(h3p4,611)]).
observations(612, [ batteryLevel(810,612), atR(h3p1,612)]).
observations(615, [ batteryLevel(807,615), atR(h3e1,615)]).
observations(617, [ batteryLevel(805,617), atR(h2e1,617)]).
observations(620, [ batteryLevel(802,620), atR(h2p1,620)]).
observations(621, [ batteryLevel(801,621), atR(h2p4,621)]).
observations(622, [ batteryLevel(800,622), atR(h2p7,622)]).
observations(625, [ batteryLevel(797,625), atR(h2e2,625)]).
observations(627, [ batteryLevel(795,627), atR(h1e2,627)]).
observations(630, [ batteryLevel(792,630), atR(h1p7,630)]).
observations(631, [ batteryLevel(791,631), atR(h1p4,631)]).
observations(632, [ batteryLevel(790,632), atR(h1p1,632)]).
observations(633, [ batteryLevel(789,633), atR(h1p3,633)]).
observations(667, [ batteryLevel(1000,667), foodLoaded(667)]).
observations(668, [ batteryLevel(999,668), atR(h1p1,668)]).
observations(669, [ batteryLevel(998,669), atR(h1p2,669)]).
observations(671, [ batteryLevel(996,671), foodAt(h1p2,671)]).
observations(672, [ batteryLevel(995,672), atR(h1p1,672)]).
observations(673, [ batteryLevel(994,673), atR(h1p4,673)]).
observations(674, [ batteryLevel(993,674), atR(h1p5,674)]).
observations(676, [ batteryLevel(991,676), foodAt(h1p5,676)]).
observations(677, [ batteryLevel(990,677), atR(h1p4,677)]).
observations(678, [ batteryLevel(989,678), atR(h1p6,678)]).
observations(680, [ batteryLevel(987,680), foodAt(h1p6,680)]).
observations(681, [ batteryLevel(986,681), atR(h1p4,681)]).
observations(682, [ batteryLevel(985,682), atR(h1p7,682)]).
observations(683, [ batteryLevel(984,683), atR(h1p8,683)]).
observations(685, [ batteryLevel(982,685), foodAt(h1p8,685)]).
observations(686, [ batteryLevel(981,686), atR(h1p7,686)]).
observations(687, [ batteryLevel(980,687), atR(h1p9,687)]).
observations(689, [ batteryLevel(978,689), foodAt(h1p9,689), foodAt(h1,689)]).
observations(690, [ batteryLevel(977,690), atR(h1p7,690)]).
observations(691, [ batteryLevel(976,691), atR(h1p4,691)]).
observations(692, [ batteryLevel(975,692), atR(h1p1,692)]).
observations(695, [ batteryLevel(972,695), atR(h1e1,695)]).
observations(697, [ batteryLevel(970,697), atR(h2e1,697)]).
observations(700, [ batteryLevel(967,700), atR(h2p1,700)]).
observations(701, [ batteryLevel(966,701), atR(h2p4,701)]).
observations(702, [ batteryLevel(965,702), atR(h2p7,702)]).
observations(703, [ batteryLevel(964,703), atR(h2p9,703)]).
observations(705, [ batteryLevel(962,705), foodAt(h2p9,705)]).
observations(706, [ batteryLevel(961,706), atR(h2p7,706)]).
observations(707, [ batteryLevel(960,707), atR(h2p8,707)]).
observations(709, [ batteryLevel(958,709), foodAt(h2p8,709)]).
observations(710, [ batteryLevel(957,710), atR(h2p7,710)]).
observations(713, [ batteryLevel(954,713), atR(h2e2,713)]).
observations(715, [ batteryLevel(952,715), atR(h1e2,715)]).
observations(718, [ batteryLevel(949,718), atR(h1p7,718)]).
observations(719, [ batteryLevel(948,719), atR(h1p4,719)]).
observations(720, [ batteryLevel(947,720), atR(h1p1,720)]).
observations(723, [ batteryLevel(944,723), atR(h1e1,723)]).
observations(725, [ batteryLevel(942,725), atR(h2e1,725)]).
observations(728, [ batteryLevel(939,728), atR(h2p1,728)]).
observations(729, [ batteryLevel(938,729), atR(h2p4,729)]).
observations(730, [ batteryLevel(937,730), atR(h2p6,730)]).
observations(732, [ batteryLevel(935,732), foodAt(h2p6,732)]).
observations(733, [ batteryLevel(934,733), atR(h2p4,733)]).
observations(734, [ batteryLevel(933,734), atR(h2p5,734)]).
observations(736, [ batteryLevel(931,736), foodAt(h2p5,736)]).
observations(737, [ batteryLevel(930,737), atR(h2p4,737)]).
observations(738, [ batteryLevel(929,738), atR(h2p1,738)]).
observations(739, [ batteryLevel(928,739), atR(h2p3,739)]).
observations(741, [ batteryLevel(926,741), foodAt(h2p3,741)]).
observations(742, [ batteryLevel(925,742), atR(h2p1,742)]).
observations(743, [ batteryLevel(924,743), atR(h2p2,743)]).
observations(745, [ batteryLevel(922,745), foodAt(h2p2,745), foodAt(h2,745)]).
observations(746, [ batteryLevel(921,746), atR(h2p1,746)]).
observations(747, [ batteryLevel(920,747), atR(h2p4,747)]).
observations(748, [ batteryLevel(919,748), atR(h2p7,748)]).
observations(751, [ batteryLevel(916,751), atR(h2e2,751)]).
observations(753, [ batteryLevel(914,753), atR(h3e2,753)]).
observations(756, [ batteryLevel(911,756), atR(h3p7,756)]).
observations(757, [ batteryLevel(910,757), atR(h3p4,757)]).
observations(758, [ batteryLevel(909,758), atR(h3p1,758)]).
observations(759, [ batteryLevel(908,759), atR(h3p3,759)]).
observations(761, [ batteryLevel(906,761), foodAt(h3p3,761)]).
observations(762, [ batteryLevel(905,762), atR(h3p1,762)]).
observations(763, [ batteryLevel(904,763), atR(h3p2,763)]).
observations(765, [ batteryLevel(902,765), foodAt(h3p2,765)]).
observations(766, [ batteryLevel(901,766), atR(h3p1,766)]).
observations(767, [ batteryLevel(900,767), atR(h3p4,767)]).
observations(768, [ batteryLevel(899,768), atR(h3p5,768)]).
observations(770, [ batteryLevel(897,770), foodAt(h3p5,770)]).
observations(771, [ batteryLevel(896,771), atR(h3p4,771)]).
observations(772, [ batteryLevel(895,772), atR(h3p6,772)]).
observations(774, [ batteryLevel(893,774), foodAt(h3p6,774)]).
observations(775, [ batteryLevel(892,775), atR(h3p4,775)]).
observations(776, [ batteryLevel(891,776), atR(h3p7,776)]).
observations(777, [ batteryLevel(890,777), atR(h3p8,777)]).
observations(779, [ batteryLevel(888,779), foodAt(h3p8,779)]).
observations(780, [ batteryLevel(887,780), atR(h3p7,780)]).
observations(781, [ batteryLevel(886,781), atR(h3p9,781)]).
observations(783, [ batteryLevel(884,783), foodAt(h3p9,783), foodAt(h3,783)]).
observations(784, [ batteryLevel(883,784), atR(h3p7,784)]).
observations(785, [ batteryLevel(882,785), atR(h3p4,785)]).
observations(786, [ batteryLevel(881,786), atR(h3p1,786)]).
observations(789, [ batteryLevel(878,789), atR(h3e1,789)]).
observations(791, [ batteryLevel(876,791), atR(h4e1,791)]).
observations(794, [ batteryLevel(873,794), atR(h4p1,794)]).
observations(795, [ batteryLevel(872,795), atR(h4p4,795)]).
observations(796, [ batteryLevel(871,796), atR(h4p7,796)]).
observations(797, [ batteryLevel(870,797), atR(h4p9,797)]).
observations(799, [ batteryLevel(868,799), foodAt(h4p9,799)]).
observations(800, [ batteryLevel(867,800), atR(h4p7,800)]).
observations(801, [ batteryLevel(866,801), atR(h4p8,801)]).
observations(803, [ batteryLevel(864,803), foodAt(h4p8,803)]).
observations(804, [ batteryLevel(863,804), atR(h4p7,804)]).
observations(807, [ batteryLevel(860,807), atR(h4e2,807)]).
observations(809, [ batteryLevel(858,809), atR(h3e2,809)]).
observations(812, [ batteryLevel(855,812), atR(h3p7,812)]).
observations(813, [ batteryLevel(854,813), atR(h3p4,813)]).
observations(814, [ batteryLevel(853,814), atR(h3p1,814)]).
observations(817, [ batteryLevel(850,817), atR(h3e1,817)]).
observations(819, [ batteryLevel(848,819), atR(h4e1,819)]).
observations(822, [ batteryLevel(845,822), atR(h4p1,822)]).
observations(823, [ batteryLevel(844,823), atR(h4p4,823)]).
observations(824, [ batteryLevel(843,824), atR(h4p6,824)]).
observations(826, [ batteryLevel(841,826), foodAt(h4p6,826)]).
observations(827, [ batteryLevel(840,827), atR(h4p4,827)]).
observations(828, [ batteryLevel(839,828), atR(h4p5,828)]).
observations(830, [ batteryLevel(837,830), foodAt(h4p5,830)]).
observations(831, [ batteryLevel(836,831), atR(h4p4,831)]).
observations(832, [ batteryLevel(835,832), atR(h4p1,832)]).
observations(833, [ batteryLevel(834,833), atR(h4p3,833)]).
observations(835, [ batteryLevel(832,835), foodAt(h4p3,835)]).
observations(836, [ batteryLevel(831,836), atR(h4p1,836)]).
observations(837, [ batteryLevel(830,837), atR(h4p2,837)]).
observations(839, [ batteryLevel(828,839), foodAt(h4p2,839), foodAt(h4,839)]).
observations(840, [ batteryLevel(827,840), atR(h4p1,840)]).
observations(841, [ batteryLevel(826,841), atR(h4p4,841)]).
observations(842, [ batteryLevel(825,842), atR(h4p7,842)]).
observations(845, [ batteryLevel(822,845), atR(h4e2,845)]).
observations(847, [ batteryLevel(820,847), atR(h3e2,847)]).
observations(850, [ batteryLevel(817,850), atR(h3p7,850)]).
observations(851, [ batteryLevel(816,851), atR(h3p4,851)]).
observations(852, [ batteryLevel(815,852), atR(h3p1,852)]).
observations(855, [ batteryLevel(812,855), atR(h3e1,855)]).
observations(857, [ batteryLevel(810,857), atR(h2e1,857)]).
observations(860, [ batteryLevel(807,860), atR(h2p1,860)]).
observations(861, [ batteryLevel(806,861), atR(h2p4,861)]).
observations(862, [ batteryLevel(805,862), atR(h2p7,862)]).
observations(865, [ batteryLevel(802,865), atR(h2e2,865)]).
observations(867, [ batteryLevel(800,867), atR(h1e2,867)]).
observations(870, [ batteryLevel(797,870), atR(h1p7,870)]).
observations(871, [ batteryLevel(796,871), atR(h1p4,871)]).
observations(872, [ batteryLevel(795,872), atR(h1p1,872)]).
observations(873, [ batteryLevel(794,873), atR(h1p3,873)]).
observations(874, [ batteryLevel(793,874), atR(h1p1,874)]).
observations(875, [ batteryLevel(792,875), atR(h1p2,875)]).
observations(876, [ batteryLevel(791,876), dishesCollected(h1p2,876)]).
observations(877, [ batteryLevel(790,877), atR(h1p1,877)]).
observations(878, [ batteryLevel(789,878), atR(h1p4,878)]).
observations(879, [ batteryLevel(788,879), atR(h1p5,879)]).
observations(880, [ batteryLevel(787,880), dishesCollected(h1p5,880)]).
observations(881, [ batteryLevel(786,881), atR(h1p4,881)]).
observations(882, [ batteryLevel(785,882), atR(h1p6,882)]).
observations(883, [ batteryLevel(784,883), dishesCollected(h1p6,883)]).
observations(884, [ batteryLevel(783,884), atR(h1p4,884)]).
observations(885, [ batteryLevel(782,885), atR(h1p7,885)]).
observations(886, [ batteryLevel(781,886), atR(h1p8,886)]).
observations(887, [ batteryLevel(780,887), dishesCollected(h1p8,887)]).
observations(888, [ batteryLevel(779,888), atR(h1p7,888)]).
observations(889, [ batteryLevel(778,889), atR(h1p9,889)]).
observations(890, [ batteryLevel(777,890), dishesCollected(h1p9,890), dishesCollected(h1,890)]).
observations(891, [ batteryLevel(776,891), atR(h1p7,891)]).
observations(892, [ batteryLevel(775,892), atR(h1p4,892)]).
observations(893, [ batteryLevel(774,893), atR(h1p1,893)]).
observations(896, [ batteryLevel(771,896), atR(h1e1,896)]).
observations(898, [ batteryLevel(769,898), atR(h2e1,898)]).
observations(901, [ batteryLevel(766,901), atR(h2p1,901)]).
observations(902, [ batteryLevel(765,902), atR(h2p4,902)]).
observations(903, [ batteryLevel(764,903), atR(h2p7,903)]).
observations(904, [ batteryLevel(763,904), atR(h2p9,904)]).
observations(905, [ batteryLevel(762,905), dishesCollected(h2p9,905)]).
observations(906, [ batteryLevel(761,906), atR(h2p7,906)]).
observations(907, [ batteryLevel(760,907), atR(h2p8,907)]).
observations(908, [ batteryLevel(759,908), dishesCollected(h2p8,908)]).
observations(909, [ batteryLevel(758,909), atR(h2p7,909)]).
observations(912, [ batteryLevel(755,912), atR(h2e2,912)]).
observations(914, [ batteryLevel(753,914), atR(h1e2,914)]).
observations(917, [ batteryLevel(750,917), atR(h1p7,917)]).
observations(918, [ batteryLevel(749,918), atR(h1p4,918)]).
observations(919, [ batteryLevel(748,919), atR(h1p1,919)]).
observations(922, [ batteryLevel(745,922), atR(h1e1,922)]).
observations(924, [ batteryLevel(743,924), atR(h2e1,924)]).
observations(927, [ batteryLevel(740,927), atR(h2p1,927)]).
observations(928, [ batteryLevel(739,928), atR(h2p4,928)]).
observations(929, [ batteryLevel(738,929), atR(h2p6,929)]).
observations(930, [ batteryLevel(737,930), dishesCollected(h2p6,930)]).
observations(931, [ batteryLevel(736,931), atR(h2p4,931)]).
observations(932, [ batteryLevel(735,932), atR(h2p5,932)]).
observations(933, [ batteryLevel(734,933), dishesCollected(h2p5,933)]).
observations(934, [ batteryLevel(733,934), atR(h2p4,934)]).
observations(935, [ batteryLevel(732,935), atR(h2p1,935)]).
observations(936, [ batteryLevel(731,936), atR(h2p3,936)]).
observations(937, [ batteryLevel(730,937), dishesCollected(h2p3,937)]).
observations(938, [ batteryLevel(729,938), atR(h2p1,938)]).
observations(939, [ batteryLevel(728,939), atR(h2p2,939)]).
observations(940, [ batteryLevel(727,940), dishesCollected(h2p2,940), dishesCollected(h2,940)]).
observations(941, [ batteryLevel(726,941), atR(h2p1,941)]).
observations(942, [ batteryLevel(725,942), atR(h2p4,942)]).
observations(943, [ batteryLevel(724,943), atR(h2p7,943)]).
observations(946, [ batteryLevel(721,946), atR(h2e2,946)]).
observations(948, [ batteryLevel(719,948), atR(h3e2,948)]).
observations(951, [ batteryLevel(716,951), atR(h3p7,951)]).
observations(952, [ batteryLevel(715,952), atR(h3p4,952)]).
observations(953, [ batteryLevel(714,953), atR(h3p1,953)]).
observations(954, [ batteryLevel(713,954), atR(h3p3,954)]).
observations(955, [ batteryLevel(712,955), dishesCollected(h3p3,955)]).
observations(956, [ batteryLevel(711,956), atR(h3p1,956)]).
observations(957, [ batteryLevel(710,957), atR(h3p2,957)]).
observations(958, [ batteryLevel(709,958), dishesCollected(h3p2,958)]).
observations(959, [ batteryLevel(708,959), atR(h3p1,959)]).
observations(960, [ batteryLevel(707,960), atR(h3p4,960)]).
observations(961, [ batteryLevel(706,961), atR(h3p5,961)]).
observations(962, [ batteryLevel(705,962), dishesCollected(h3p5,962)]).
observations(963, [ batteryLevel(704,963), atR(h3p4,963)]).
observations(964, [ batteryLevel(703,964), atR(h3p6,964)]).
observations(965, [ batteryLevel(702,965), dishesCollected(h3p6,965)]).
observations(966, [ batteryLevel(701,966), atR(h3p4,966)]).
observations(967, [ batteryLevel(700,967), atR(h3p7,967)]).
observations(968, [ batteryLevel(699,968), atR(h3p8,968)]).
observations(969, [ batteryLevel(698,969), dishesCollected(h3p8,969)]).
observations(970, [ batteryLevel(697,970), atR(h3p7,970)]).
observations(971, [ batteryLevel(696,971), atR(h3p9,971)]).
observations(972, [ batteryLevel(695,972), dishesCollected(h3p9,972), dishesCollected(h3,972)]).
observations(973, [ batteryLevel(694,973), atR(h3p7,973)]).
observations(974, [ batteryLevel(693,974), atR(h3p4,974)]).
observations(975, [ batteryLevel(692,975), atR(h3p1,975)]).
observations(978, [ batteryLevel(689,978), atR(h3e1,978)]).
observations(980, [ batteryLevel(687,980), atR(h4e1,980)]).
observations(983, [ batteryLevel(684,983), atR(h4p1,983)]).
observations(984, [ batteryLevel(683,984), atR(h4p4,984)]).
observations(985, [ batteryLevel(682,985), atR(h4p7,985)]).
observations(986, [ batteryLevel(681,986), atR(h4p9,986)]).
observations(987, [ batteryLevel(680,987), dishesCollected(h4p9,987)]).
observations(988, [ batteryLevel(679,988), atR(h4p7,988)]).
observations(989, [ batteryLevel(678,989), atR(h4p8,989)]).
observations(990, [ batteryLevel(677,990), dishesCollected(h4p8,990)]).
observations(991, [ batteryLevel(676,991), atR(h4p7,991)]).
observations(994, [ batteryLevel(673,994), atR(h4e2,994)]).
observations(996, [ batteryLevel(671,996), atR(h3e2,996)]).
observations(999, [ batteryLevel(668,999), atR(h3p7,999)]).
observations(1000, [ batteryLevel(667,1000), atR(h3p4,1000)]).
observations(1001, [ batteryLevel(666,1001), atR(h3p1,1001)]).
observations(1004, [ batteryLevel(663,1004), atR(h3e1,1004)]).
observations(1006, [ batteryLevel(661,1006), atR(h4e1,1006)]).
observations(1009, [ batteryLevel(658,1009), atR(h4p1,1009)]).
observations(1010, [ batteryLevel(657,1010), atR(h4p4,1010)]).
observations(1011, [ batteryLevel(656,1011), atR(h4p6,1011)]).
observations(1012, [ batteryLevel(655,1012), dishesCollected(h4p6,1012)]).
observations(1013, [ batteryLevel(654,1013), atR(h4p4,1013)]).
observations(1014, [ batteryLevel(653,1014), atR(h4p5,1014)]).
observations(1015, [ batteryLevel(652,1015), dishesCollected(h4p5,1015)]).
observations(1016, [ batteryLevel(651,1016), atR(h4p4,1016)]).
observations(1017, [ batteryLevel(650,1017), atR(h4p1,1017)]).
observations(1018, [ batteryLevel(649,1018), atR(h4p3,1018)]).
observations(1019, [ batteryLevel(648,1019), dishesCollected(h4p3,1019)]).
observations(1020, [ batteryLevel(647,1020), atR(h4p1,1020)]).
observations(1021, [ batteryLevel(646,1021), atR(h4p2,1021)]).
observations(1022, [ batteryLevel(645,1022), dishesCollected(h4p2,1022), dishesCollected(h4,1022)]).
observations(1023, [ batteryLevel(644,1023), atR(h4p1,1023)]).
observations(1024, [ batteryLevel(643,1024), atR(h4p4,1024)]).
observations(1025, [ batteryLevel(642,1025), atR(h4p7,1025)]).
observations(1028, [ batteryLevel(639,1028), atR(h4e2,1028)]).
observations(1030, [ batteryLevel(637,1030), atR(h3e2,1030)]).
observations(1033, [ batteryLevel(634,1033), atR(h3p7,1033)]).
observations(1034, [ batteryLevel(633,1034), atR(h3p4,1034)]).
observations(1035, [ batteryLevel(632,1035), atR(h3p1,1035)]).
observations(1038, [ batteryLevel(629,1038), atR(h3e1,1038)]).
observations(1040, [ batteryLevel(627,1040), atR(h2e1,1040)]).
observations(1043, [ batteryLevel(624,1043), atR(h2p1,1043)]).
observations(1044, [ batteryLevel(623,1044), atR(h2p4,1044)]).
observations(1045, [ batteryLevel(622,1045), atR(h2p7,1045)]).
observations(1048, [ batteryLevel(619,1048), atR(h2e2,1048)]).
observations(1050, [ batteryLevel(617,1050), atR(h1e2,1050)]).
observations(1053, [ batteryLevel(614,1053), atR(h1p7,1053)]).
observations(1054, [ batteryLevel(613,1054), atR(h1p4,1054)]).
observations(1055, [ batteryLevel(612,1055), atR(h1p1,1055)]).
observations(1056, [ batteryLevel(611,1056), atR(h1p3,1056)]).
observations(1439, [ batteryLevel(1000,1439)]).
observations(_,[]).
