extern char tetrom_colors[7];

enum drawmode {
	DRAW_PIECE,
	DRAW_BLOCKS,
	CLEAR_BLOCKS
};

typedef const struct player *Player;
typedef const struct tetr   *Tetr;
typedef enum drawmode        Drawmode;

void drawgamescreen_1p();
void drawgamescreen_2p();

void drawnext(Player p, Tetr next);

/* x and y here means column and row in the player's playfield */

void drawblocks(Player p, int bl, int x, int y, Drawmode mode);
#define drawpiece(plr, bl, x, y)   drawblocks(plr, bl, x, y, DRAW_PIECE)
#define clearblocks(plr, bl, x, y) drawblocks(plr, bl, x, y, CLEAR_BLOCKS)

void drawrow(Player p, int y);

/* redraw row y and all rows above */
void redrawboard(Player p, int y);

void upd_screen(Player p);
void upd_stat(Player p, int levelup);
void upd_garbagemeter(Player p, int n);
void show_winner(Player p);
