#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>
#include <time.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include "textgfx/textgfx.h"
#include "tetris.h"
#include "prolog-io.h"

struct game game = {GAME_NULL};

static void finish(int sig)
{
	exit(0);
}

int main(int argc, char **argv)
{
	int level = 0;
	int subgoal = 0;
	while (argc > 1 && (argv[1][0] == '-' || isdigit(argv[1][0]))) {
		if (!strcmp(argv[0], "-level"))
			level = atoi(argv[1]);
		else if (!strcmp(argv[1], "-white"))
			textgfx_flags = WHITE_BG;
		else if (!strcmp(argv[1], "-subgoal"))
			subgoal = 1;
		argv++;
		argc--;
	}
	if (!spawn_prolog(argc, argv))
		return 1;
	atexit(stop_prolog);
	signal(SIGINT, finish);
	signal(SIGPIPE, finish);
	gettermsize();
	gettermenv();
	textgfx_init();
	atexit(textgfx_end);
	bgdot = default_bgdot;

	srand(time(NULL));
	game.state = GAME_CREATED;
	game.mode  = MODE_1P;
	player1.startlevel = level % 10;
	player1.height     = 0;
	player1.rotation   = (ROT_CLOCKWISE | ROT_LEFTHAND);

	setupplayer(&player1);
	if (subgoal) {
		srand(4);
		game.player[0].board[17] = 0x249 << 3*3;
		game.player[0].board[18] = 0x001 << 4*3;
		game.player[0].board[19] = 0x049 << 3*3;
	}
	startgame_1p();

	prolog_command("halt");
	textgfx_end();
	return 0;
}
