#include <stdio.h>
#include <string.h>
#include "tetris.h"
#include "prolog-io.h"

static const char *tetrom_atoms = " istolzj";

void obs_next()
{
	char s[] = "x)).\n";
	write_prolog_str("make_obs(next(");
	s[0] = tetrom_atoms[(int)player1.next->color];
	write_prolog_str(s);
}

void obs_playfield()
{
	char s[16];
	int first=1;
	int i,j;
	write_prolog_str("make_obs(blocks([");
	for (i=0; i<20; i++) {
		for (j=0; j<10; j++) {
			if ((player1.board[i]>>(3*j)) & 7) {
				sprintf(s, ",pos(%d,%d)", j+1, 20-i);
				if (first)
					s[0]=' ';
				first=0;
				write_prolog_str(s);
			}
		}
	}
	write_prolog_str("])).\n");
}

void obs_piece()
{
	int a = tetrom_atoms[(int)player1.piece.color];
	int i = player1.piece.state;
	int x = player1.piece.x+1;
	int y = 18-player1.piece.y;

	switch (a) {
	case 'i': i %= 2; y--; break;
	case 'o': i = 0;  y++; break;
	case 's':
	case 'z': i %= 2;
	}

	char s[] = "tetromino(x,i),pos(";
	s[10] = a;
	s[12] = i+'1';
	write_prolog_str("make_obs(at(");
	write_prolog_str(s);
	sprintf(s, "%d,%d))).\n", x, y);
	write_prolog_str(s);
}
