#include "textgfx.h"

#define TEXT_COLOR(bg, fg, bold) ((bg)|(fg)<<3|(bold)<<6)
#define TEXT_COLOR_BG(color)   ((color) & 7)
#define TEXT_COLOR_FG(color)   (((color)>>3) & 7)
#define TEXT_COLOR_BOLD(color) ((color)>>6)

static unsigned char colorpairs[] = {
	0,
	TEXT_COLOR(1, 1, 1),
	TEXT_COLOR(2, 2, 1),
	TEXT_COLOR(3, 3, 1),
	TEXT_COLOR(4, 4, 1),
	TEXT_COLOR(5, 5, 1),
	TEXT_COLOR(6, 6, 1),
	TEXT_COLOR(7, 7, 1),
	TEXT_COLOR(0, 5, 1),	/* MAGENTA_FG */
	TEXT_COLOR(4, 7, 1),	/* WHITE_ON_BLUE */
	TEXT_COLOR(0, 4, 0),	/* BOARD_BG_COLOR */
	TEXT_COLOR(0, 4, 0),	/* BOARD_FRAME_COLOR */
	TEXT_COLOR(4, 3, 1),	/* PANEL_LABEL_COLOR */
	TEXT_COLOR(0, 1, 1),	/* RED_FG */
	TEXT_COLOR(2, 3, 1),	/* YELLOW_ON_GREEN */
	TEXT_COLOR(4, 3, 1),	/* YELLOW_ON_BLUE */
	0,
	TEXT_COLOR(0, 1, 1),
	TEXT_COLOR(0, 2, 1),
	TEXT_COLOR(0, 3, 1),
	TEXT_COLOR(0, 4, 1),
	TEXT_COLOR(0, 5, 1),
	TEXT_COLOR(0, 6, 1),
	TEXT_COLOR(0, 7, 1)
};

void initcolorpair(int pair, int bg, int fg, int bold)
{
	colorpairs[pair] = TEXT_COLOR(bg, fg, bold);
}

void setcolorpair(int pair)
{
	int color;
	int bg, fg, bold;

	if (_MONOCHROME) {
		if (pair == MAGENTA_FG)
			setattr_bold();
	} else {
		color = colorpairs[pair];
		bg = TEXT_COLOR_BG(color);
		fg = TEXT_COLOR_FG(color);
		bold = TEXT_COLOR_BOLD(color);
		if (!bg || _TT_BLOCKS)
			bg = -1;
		if (_WHITE_BG && bg == 7) {
			bg = 0;
			if (fg == 7)
				fg = 0;
		}
		set_color_pair(pair, bg, fg, bold);
	}
}
